From 919085cd8b104460df58a761fed1c14ed8eedcb9 Mon Sep 17 00:00:00 2001
From: David Tolnay <dtolnay@gmail.com>
Date: Nov 01 2020 06:12:25 +0000
Subject: [PATCH 1153/2232] Add builtin for PtrLen


---

diff --git a/gen/src/builtin.rs b/gen/src/builtin.rs
index a1393b5..8a65b5f 100644
--- a/gen/src/builtin.rs
+++ b/gen/src/builtin.rs
@@ -16,6 +16,7 @@ pub struct Builtins {
     pub manually_drop: bool,
     pub maybe_uninit: bool,
     pub trycatch: bool,
+    pub ptr_len: bool,
     pub rust_str_new_unchecked: bool,
     pub rust_str_repr: bool,
     pub content: Content,
@@ -90,11 +91,7 @@ pub(super) fn write(out: &mut OutFile) {
 
     out.begin_block("namespace");
 
-    if builtin.trycatch
-        || builtin.rust_error
-        || builtin.rust_str_new_unchecked
-        || builtin.rust_str_repr
-    {
+    if builtin.ptr_len {
         out.begin_block("namespace repr");
         writeln!(out, "struct PtrLen final {{");
         writeln!(out, "  const void *ptr;");
diff --git a/gen/src/write.rs b/gen/src/write.rs
index c690995..8af2fe5 100644
--- a/gen/src/write.rs
+++ b/gen/src/write.rs
@@ -353,6 +353,7 @@ fn write_cxx_function_shim(out: &mut OutFile, efn: &ExternFn, impl_annotations: 
         write!(out, "{} ", annotation);
     }
     if efn.throws {
+        out.builtin.ptr_len = true;
         write!(out, "::rust::repr::PtrLen ");
     } else {
         write_extern_return_type_space(out, &efn.ret);
@@ -425,6 +426,7 @@ fn write_cxx_function_shim(out: &mut OutFile, efn: &ExternFn, impl_annotations: 
     writeln!(out, ";");
     write!(out, "  ");
     if efn.throws {
+        out.builtin.ptr_len = true;
         out.builtin.trycatch = true;
         writeln!(out, "::rust::repr::PtrLen throw$;");
         writeln!(out, "  ::rust::behavior::trycatch(");
@@ -551,6 +553,7 @@ fn write_rust_function_decl_impl(
     indirect_call: bool,
 ) {
     if sig.throws {
+        out.builtin.ptr_len = true;
         write!(out, "::rust::repr::PtrLen ");
     } else {
         write_extern_return_type_space(out, &sig.ret);
@@ -695,6 +698,7 @@ fn write_rust_function_shim_impl(
         }
     }
     if sig.throws {
+        out.builtin.ptr_len = true;
         write!(out, "::rust::repr::PtrLen error$ = ");
     }
     write!(out, "{}(", invoke);
@@ -811,7 +815,10 @@ fn write_extern_return_type_space(out: &mut OutFile, ty: &Option<Type>) {
             write_type(out, &ty.inner);
             write!(out, " *");
         }
-        Some(Type::Str(_)) => write!(out, "::rust::repr::PtrLen "),
+        Some(Type::Str(_)) => {
+            out.builtin.ptr_len = true;
+            write!(out, "::rust::repr::PtrLen ");
+        }
         Some(Type::SliceRefU8(_)) => write!(out, "::rust::Slice<uint8_t>::Repr "),
         Some(ty) if out.types.needs_indirect_abi(ty) => write!(out, "void "),
         _ => write_return_type(out, ty),
@@ -824,7 +831,10 @@ fn write_extern_arg(out: &mut OutFile, arg: &Var) {
             write_type_space(out, &ty.inner);
             write!(out, "*");
         }
-        Type::Str(_) => write!(out, "::rust::repr::PtrLen "),
+        Type::Str(_) => {
+            out.builtin.ptr_len = true;
+            write!(out, "::rust::repr::PtrLen ");
+        }
         Type::SliceRefU8(_) => write!(out, "::rust::Slice<uint8_t>::Repr "),
         _ => write_type_space(out, &arg.ty),
     }

